; input routines

!ifdef INCLUDE_INPUT !eof
!if INCLUDE_GUARD > 0 {
INCLUDE_INPUT = 1
}

!zn Input {

INPUT_NONE = 0
INPUT_U = 1
INPUT_D = 2
INPUT_L = 3
INPUT_R = 4
INPUT_UL = 5
INPUT_UR = 6
INPUT_DL = 7
INPUT_DR = 8
INPUT_SELECT = 9
INPUT_DEBUG = 10

.k_getinkbd = $f1f9 ;$ffe4

get_input_wait_irq:
    lda #1
    sta irq_downcount
-   lda irq_downcount
    bne -
    ; FALL THROUGH

get_input:
    jsr .k_getinkbd
    ldx #0
-   cmp .input_tbl_in,x
    beq .get_input_found
    bcc .get_input_not_found
    inx
    bne -   ; bra
.get_input_not_found:
    lda #INPUT_NONE
    rts
.get_input_found:
    lda .input_tbl_out,x
    rts

flush_input:
-   jsr get_input
    bne -
    rts

.input_tbl_in:
; NOTE these are sorted
!by $00
!if DEBUG_KEY > 0 {
!by $03 ; r/s
}
;   rtrn a    c    d    e    q    s    w    x    z
!by $0d, $41, $43, $44, $45, $51, $53, $57, $58, $5a

.input_tbl_out:
!by INPUT_NONE
!if DEBUG_KEY > 0 {
!by INPUT_DEBUG
}
!by INPUT_SELECT
!by INPUT_L
!by INPUT_DR
!by INPUT_R
!by INPUT_UR
!by INPUT_UL
!by INPUT_D
!by INPUT_U
!by INPUT_D
!by INPUT_DL

; direction to arena offset
tbl_input_dir:
; assumes order:
;      U,       D,      L,  R, UL,          UR,          DL,         DR,         select
!by 0, -AREA_W, AREA_W, -1, 1, -AREA_W - 1, -AREA_W + 1, AREA_W - 1, AREA_W + 1, 0
!if DEBUG_KEY > 0 {
!by $0  ; debug
}

} ; !zn Input
